//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  DarkGray
#property indicator_color2  PaleVioletRed
#property indicator_width2  2
#property indicator_style1  STYLE_DOT

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    Price            = PRICE_CLOSE;
extern bool   CatmullRomSpline = false;

double line[];
double price[];
int    timeFrame;
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   SetIndexBuffer(0,price);
   SetIndexBuffer(1,line);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);

      //
      //
      //
      //
      //

   IndicatorShortName(timeFrameToString(timeFrame)+" cubic spline trend line");
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { price[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(int i=limit; i>=0; i--)
   {
      int t = iBarShift(NULL,timeFrame,Time[i]);
            price[i] = iMA(NULL,timeFrame,1,0,MODE_SMA,Price,t);
      if (t==iBarShift(NULL,timeFrame,Time[i-1])) continue;
      
      //
      //
      //
      //
      //
      
         double y0 = iMA(NULL,timeFrame,1,0,MODE_SMA,Price,MathMax(t-1,0));
         double y1 = iMA(NULL,timeFrame,1,0,MODE_SMA,Price,t+0);
         double y2 = iMA(NULL,timeFrame,1,0,MODE_SMA,Price,t+1);
         double y3 = iMA(NULL,timeFrame,1,0,MODE_SMA,Price,t+2);
         
            if (!CatmullRomSpline)
               {
                  double a0 = -y0 + y1 - y2 + y3;
                  double a1 =  y0 - y1 - a0;
                  double a2 = -y0 + y2;
                  double a3 =  y1;
               }
            else
               {
                         a0 = -0.5*y0 + 1.5*y1 - 1.5*y2 + 0.5*y3;
                         a1 =      y0 - 2.5*y1 + 2.0*y2 - 0.5*y3;
                         a2 = -0.5*y0          + 0.5*y2;
                         a3 =               y1;
               }

      //
      //
      //
      //
      //
         
      datetime time = iTime(NULL,timeFrame,t);
         for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
         for(int k = 0; k < n; k++)
         {
            double mu  = 1.0*k/n;
            double mu2 = mu*mu;
              line[i+k] = (a0*mu*mu2+a1*mu2+a2*mu+a3);
         }                 
   }
   return(0);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}